diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index cf695d47a..2383491e3 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -29,6 +29,10 @@ import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.block.model.BlockModelGrass;
+import net.minecraft.client.render.font.FontDefault;
+import net.minecraft.client.render.font.FontMonospace;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.achievement.Achievements;
@@ -78,6 +82,7 @@ import javax.swing.JOptionPane;
 
 import net.minecraft.client.gui.subtitles.SubtitleTracker;
 import net.minecraft.client.sound.SoundRepository;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import org.lwjgl.LWJGLException;
@@ -108,7 +113,6 @@ import net.minecraft.client.player.controller.PlayerController;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FallbackRenderer;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.LoadingScreenRenderer;
@@ -218,8 +222,8 @@ public class Minecraft
     public String minecraftUri;
     public boolean hideQuitButton;
     public volatile boolean isGamePaused;
-    public TextureManager textureManager;
-    public Font font;
+    public final @NotNull TextureManager textureManager;
+    public final @NotNull FontRenderer font;
     /**
      * Current gui the player is looking at
      * is null when in a world during normal play
@@ -228,23 +232,22 @@ public class Minecraft
     public LoadingScreenRenderer loadingScreen;
     public WorldRenderer worldRenderer;
     public ThreadDownloadResources downloadResourcesThread;
-    private int ticksRan;
+    public int ticksRan;
     public GuiElementToastsHud guiToasts;
     public HudIngame hudIngame;
     public boolean skipRenderWorld;
     public HitResult objectMouseOver;
-    public GameSettings gameSettings;
+    public final @NotNull GameSettings gameSettings;
     public SoundEngine sndManager;
-    public final SubtitleTracker subtitleTracker = new SubtitleTracker();
-    public TexturePackList texturePackList;
-    private File mcDataDir;
+    public final @NotNull SubtitleTracker subtitleTracker = new SubtitleTracker();
+    public final @NotNull TexturePackList texturePackList;
+    private final @NotNull File mcDataDir;
     private ISaveFormat saveFormat;
     public static int numRecordedFrameTimes = 0;
     public static long hasPaidCheckTime = 0L;
     public StatsCounter statsCounter;
     private String serverName;
     private int serverPort;
-    private static File minecraftDir = null;
     public volatile boolean running;
     public String debug;
     public String debugFPS;
@@ -284,7 +287,7 @@ public class Minecraft
      * Keep this as the only constructor in this class for now,
      * otherwise JVM class verification will fail and the game will crash when the fabric loader tries to run the game.
      */
-    public Minecraft(GameWindow gameWindow, boolean test)
+    public Minecraft(final @NotNull File mcDataDir, final GameWindow gameWindow, final boolean test)
     {
         Global.accessor = this;
         hasCrashed = false;
@@ -306,6 +309,12 @@ public class Minecraft
         joinPlayerCounter = 0;
         INSTANCE = this;
 
+        this.mcDataDir = mcDataDir;
+        this.gameSettings = new GameSettings(this, mcDataDir);
+        this.texturePackList = new TexturePackList(this, this.mcDataDir);
+        this.textureManager = new TextureManager(this, this.texturePackList, this.gameSettings);
+        this.font = new FontRendererDefault(new FontDefault(this.textureManager));
+
         if(test) return;
 
         this.gameWindow = gameWindow;
@@ -456,7 +465,6 @@ public class Minecraft
     public void startGame() throws LWJGLException
     {
         ImageIO.setUseCache(false); // Speeds up boot time
-		mcDataDir = getMinecraftDir();
 
         // Initialize LogMessageReceiver to capture output
         LogMessageReceiver.init();
@@ -472,7 +480,7 @@ public class Minecraft
         CommandHelper.init();
         initCommands();
 
-		gameSettings = new GameSettings(this, mcDataDir);
+        this.gameSettings.init();
 
         LOGGER.info("Java Version: {}", System.getProperty("java.version"));
 
@@ -523,10 +531,9 @@ public class Minecraft
             setRenderer(new FallbackRenderer(this));
         }
 
-        texturePackList = new TexturePackList(this, mcDataDir);
-        textureManager = new TextureManager(this, texturePackList, gameSettings);
+        this.texturePackList.init();
 
-        TooltipElement.reloadStyles(texturePackList);
+        TooltipElement.reloadStyles(this.texturePackList);
         SoundRepository.initialize(this);
 
         // Show load screen as early as possible
@@ -795,13 +802,8 @@ public class Minecraft
         tessellator.draw();
     }
 
-    public File getMinecraftDir()
-    {
-        if(minecraftDir == null)
-        {
-            minecraftDir = getAppDir("minecraft-bta");
-        }
-        return minecraftDir;
+    public File getMinecraftDir() {
+        return this.mcDataDir;
     }
 
     @Override
@@ -1206,7 +1208,7 @@ public class Minecraft
 						}
 					}
 				}else {
-					hudIngame.addChatMessage(ScreenShot.saveScreenshot(minecraftDir, gameWindow.getWidthPixels(), gameWindow.getHeightPixels()));
+					hudIngame.addChatMessage(ScreenShot.saveScreenshot(getMinecraftDir(), gameWindow.getWidthPixels(), gameWindow.getHeightPixels()));
 				}
 				Debug.pop();
 			}
@@ -2624,10 +2626,10 @@ public class Minecraft
         this.renderer.reload();
     }
 
-    public static void startMainThread(@Nullable String username, @Nullable String sessionId, @Nullable String uuid, @Nullable String server, @Nullable Integer port, @Nullable Integer width, @Nullable Integer height)
+    public static void startMainThread(@Nullable String username, @Nullable String sessionId, @Nullable String uuid, @Nullable String server, @Nullable Integer port, @Nullable Integer width, @Nullable Integer height, @Nullable File mcDataDir)
     {
         GameWindow gameWindow = new GameWindowGLFW();
-        Minecraft mc = new Minecraft(gameWindow,false);
+        Minecraft mc = new Minecraft(mcDataDir == null ? getAppDir("minecraft-bta"): mcDataDir, gameWindow,false);
         mc.minecraftUri = "www.minecraft.net";
 
         sessionId = sessionId == null ? "" : sessionId;
@@ -2666,7 +2668,7 @@ public class Minecraft
 
         String playerName = null;
         String sessionId = null;
-        String gameDirectory = null;
+        File gameDirectory = null;
         String uuid = null;
         String server = null;
         Integer port = null;
@@ -2708,7 +2710,7 @@ public class Minecraft
                 }
                 case "--gameDir": {
                     try {
-                        minecraftDir = new File(args[pointer + 1]);
+                        gameDirectory = new File(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
                         e.printStackTrace();
@@ -2760,7 +2762,7 @@ public class Minecraft
                     pointer++;
             }
         }
-        startMainThread(playerName, sessionId, uuid, server, port, width, height);
+        startMainThread(playerName, sessionId, uuid, server, port, width, height, gameDirectory);
     }
     
     public void setInputType(InputType inputType) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
index 5e8331a98..2ec3b471e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
@@ -1,12 +1,9 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.window.CursorShape;
-import net.minecraft.client.render.window.GameWindowGLFW;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.glfw.GLFW;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -87,7 +84,6 @@ public class ButtonElement extends Gui implements GuiElement
     {
         if (!visible) return;
 
-        Font font = mc.font;
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
 
@@ -125,7 +121,7 @@ public class ButtonElement extends Gui implements GuiElement
                 textColor = 0xFFFFA0;
                 break;
         }
-        drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+        drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
     }
 
     public boolean isHovered(int mouseX, int mouseY)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
index cd24b7bca..868eabf83 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 public class ClickableLabelElement extends ButtonElement
@@ -62,14 +62,13 @@ public class ClickableLabelElement extends ButtonElement
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
         }
 
-        Font font = mc.font;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        width = font.getStringWidth(displayString) + 4;
+        width = MathHelper.ceil(mc.font.stringWidthDouble(displayString)) + 4;
         drawRect(xPosition, yPosition, xPosition + width, yPosition + height, enabled ? (hovered ? 0x7F8080C0 : bgColor) : 0x00000000);
         if (enabled && (shadow || hovered)) {
-            font.drawStringWithShadow(displayString, xPosition + 2, yPosition + 2, hovered ? 0xFFFFA0 : textColor);
+            drawStringShadow(mc.font, displayString, xPosition + 2, yPosition + 2, hovered ? 0xFFFFA0 : textColor);
         } else {
-            font.drawString(displayString, xPosition + 2, yPosition + 2, 0x7F7F7F);
+            drawStringNoShadow(mc.font, displayString, xPosition + 2, yPosition + 2, 0x7F7F7F);
         }
         mouseDragged(mc, mouseX, mouseY);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index 21ffbd4e9..768e35691 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -7,11 +7,8 @@ import net.minecraft.client.gui.popup.PopupCloseListener;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.command.TextFormatting;
 import org.lwjgl.Sys;
-import org.lwjgl.glfw.GLFW;
 import org.lwjgl.opengl.GL11;
 
-import java.awt.*;
-import java.awt.datatransfer.StringSelection;
 import java.text.SimpleDateFormat;
 import java.util.Date;
 import java.util.Map;
@@ -54,7 +51,7 @@ public class ExceptionPopupElement {
 
 
         PopupScreen popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.back","gui.exception.button.copy_error"},new int[]{0,1})
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
                 .build();
@@ -98,7 +95,7 @@ public class ExceptionPopupElement {
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
         PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.fatal_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
@@ -143,7 +140,7 @@ public class ExceptionPopupElement {
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
         PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.startup_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.charWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 355a19db6..b3abca07c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -2,15 +2,16 @@ package net.minecraft.client.gui;
 
 import static org.lwjgl.opengl.GL11.*;
 
-import net.minecraft.core.lang.text.Text;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import java.util.Objects;
@@ -20,144 +21,144 @@ public class Gui
 
     public Gui()
     {
-        zLevel = 0.0F;
+        this.zLevel = 0.0F;
     }
 
-    protected void drawLineHorizontal(int minX, int maxX, int minY, int argb)
+    protected void drawLineHorizontal(int minX, int maxX, final int minY, final int argb)
     {
         if(maxX < minX)
         {
-            int temp = minX;
+            final int temp = minX;
             minX = maxX;
             maxX = temp;
         }
         drawRect(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    protected void drawLineHorizontalDouble(double minX, double maxX, double minY, int argb)
+    protected void drawLineHorizontalDouble(double minX, double maxX, final double minY, final int argb)
     {
         if(maxX < minX)
         {
-            double temp = minX;
+            final double temp = minX;
             minX = maxX;
             maxX = temp;
         }
         drawRectDouble(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    protected void drawLineVertical(int minX, int minY, int maxY, int argb)
+    protected void drawLineVertical(final int minX, int minY, int maxY, final int argb)
     {
         if(maxY < minY)
         {
-            int temp = minY;
+            final int temp = minY;
             minY = maxY;
             maxY = temp;
         }
         drawRect(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    protected void drawLineVerticalDouble(double minX, double minY, double maxY, int argb)
+    protected void drawLineVerticalDouble(final double minX, double minY, double maxY, final int argb)
     {
         if(maxY < minY)
         {
-            double temp = minY;
+            final double temp = minY;
             minY = maxY;
             maxY = temp;
         }
         drawRectDouble(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    public void drawRect(int minX, int minY, int maxX, int maxY, int argb)
+    public void drawRect(int minX, int minY, int maxX, int maxY, final int argb)
     {
         if(minX < maxX)
         {
-            int temp = minX;
+            final int temp = minX;
             minX = maxX;
             maxX = temp;
         }
         if(minY < maxY)
         {
-            int temp = minY;
+            final int temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        float a = (float)(argb >> 24 & 0xff) / 255F;
-        float r = (float)(argb >> 16 & 0xff) / 255F;
-        float g = (float)(argb >> 8 & 0xff) / 255F;
-        float b = (float)(argb & 0xff) / 255F;
-        Tessellator tessellator = Tessellator.instance;
+        final float a = (float)(argb >> 24 & 0xff) / 255F;
+        final float r = (float)(argb >> 16 & 0xff) / 255F;
+        final float g = (float)(argb >> 8 & 0xff) / 255F;
+        final float b = (float)(argb & 0xff) / 255F;
+        final Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL_BLEND);
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(r, g, b, a);
         tessellator.startDrawingQuads();
-        tessellator.addVertex(minX, maxY, zLevel);
-        tessellator.addVertex(maxX, maxY, zLevel);
-        tessellator.addVertex(maxX, minY, zLevel);
-        tessellator.addVertex(minX, minY, zLevel);
+        tessellator.addVertex(minX, maxY, this.zLevel);
+        tessellator.addVertex(maxX, maxY, this.zLevel);
+        tessellator.addVertex(maxX, minY, this.zLevel);
+        tessellator.addVertex(minX, minY, this.zLevel);
         tessellator.draw();
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glDisable(GL_BLEND);
     }
-    protected void drawRectDouble(double minX, double minY, double maxX, double maxY, int argb)
+    protected void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb)
     {
         if(minX < maxX)
         {
-            double temp = minX;
+            final double temp = minX;
             minX = maxX;
             maxX = temp;
         }
         if(minY < maxY)
         {
-            double temp = minY;
+            final double temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        float a = (float)(argb >> 24 & 0xff) / 255F;
-        float r = (float)(argb >> 16 & 0xff) / 255F;
-        float g = (float)(argb >> 8 & 0xff) / 255F;
-        float b = (float)(argb & 0xff) / 255F;
-        Tessellator tessellator = Tessellator.instance;
+        final float a = (float)(argb >> 24 & 0xff) / 255F;
+        final float r = (float)(argb >> 16 & 0xff) / 255F;
+        final float g = (float)(argb >> 8 & 0xff) / 255F;
+        final float b = (float)(argb & 0xff) / 255F;
+        final Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL_BLEND);
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(r, g, b, a);
         tessellator.startDrawingQuads();
-        tessellator.addVertex(minX, maxY, zLevel);
-        tessellator.addVertex(maxX, maxY, zLevel);
-        tessellator.addVertex(maxX, minY, zLevel);
-        tessellator.addVertex(minX, minY, zLevel);
+        tessellator.addVertex(minX, maxY, this.zLevel);
+        tessellator.addVertex(maxX, maxY, this.zLevel);
+        tessellator.addVertex(maxX, minY, this.zLevel);
+        tessellator.addVertex(minX, minY, this.zLevel);
         tessellator.draw();
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glDisable(GL_BLEND);
     }
 
-    protected void drawBox(int minX, int minY, int maxX, int maxY, int argb, int lineThickness) {
+    protected void drawBox(final int minX, final int minY, final int maxX, final int maxY, final int argb, final int lineThickness) {
         drawRect(minX, minY, maxX, minY + lineThickness, argb);
         drawRect(minX, maxY - lineThickness, maxX, maxY, argb);
         drawRect(minX, minY + lineThickness, minX + lineThickness, maxY - lineThickness, argb);
         drawRect(maxX - lineThickness, minY + lineThickness, maxX, maxY - lineThickness, argb);
     }
 
-    protected void drawRectNoBlend(int minX, int minY, int maxX, int maxY, int argb)
+    protected void drawRectNoBlend(int minX, int minY, int maxX, int maxY, final int argb)
     {
         if(minX < maxX)
         {
-            int temp = minX;
+            final int temp = minX;
             minX = maxX;
             maxX = temp;
         }
         if(minY < maxY)
         {
-            int temp = minY;
+            final int temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        float a = (float)(argb >> 24 & 0xff) / 255F;
-        float r = (float)(argb >> 16 & 0xff) / 255F;
-        float g = (float)(argb >> 8 & 0xff) / 255F;
-        float b = (float)(argb & 0xff) / 255F;
-        Tessellator tessellator = Tessellator.instance;
+        final float a = (float)(argb >> 24 & 0xff) / 255F;
+        final float r = (float)(argb >> 16 & 0xff) / 255F;
+        final float g = (float)(argb >> 8 & 0xff) / 255F;
+        final float b = (float)(argb & 0xff) / 255F;
+        final Tessellator tessellator = Tessellator.instance;
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glColor4f(r, g, b, a);
         tessellator.startDrawingQuads();
@@ -169,14 +170,14 @@ public class Gui
         GL11.glEnable(GL_TEXTURE_2D);
     }
     
-    protected void drawRectWidthHeight(int x, int y, int width, int height, int argb) {
-    	float a = ((argb >> 24) & 0xFF) / 255f;
-    	float r = ((argb >> 16) & 0xFF) / 255f;
-    	float g = ((argb >>  8) & 0xFF) / 255f;
-    	float b = ((argb >>  0) & 0xFF) / 255f;
+    protected void drawRectWidthHeight(final int x, final int y, final int width, final int height, final int argb) {
+    	final float a = ((argb >> 24) & 0xFF) / 255f;
+    	final float r = ((argb >> 16) & 0xFF) / 255f;
+    	final float g = ((argb >>  8) & 0xFF) / 255f;
+    	final float b = ((argb >>  0) & 0xFF) / 255f;
     	glColor4f(r, g, b, a);
     	glDisable(GL_TEXTURE_2D);
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertex(x, y, 0);
         tessellator.addVertex(x, y+height, 0);
@@ -186,22 +187,22 @@ public class Gui
         glEnable(GL_TEXTURE_2D);
     }
 
-    protected void drawGradientRect(int minX, int minY, int maxX, int maxY, int argb1, int argb2)
+    protected void drawGradientRect(final int minX, final int minY, final int maxX, final int maxY, final int argb1, final int argb2)
     {
-        float a1 = (float)(argb1 >> 24 & 0xff) / 255F;
-        float r1 = (float)(argb1 >> 16 & 0xff) / 255F;
-        float g1 = (float)(argb1 >> 8 & 0xff) / 255F;
-        float b1 = (float)(argb1 & 0xff) / 255F;
-        float a2 = (float)(argb2 >> 24 & 0xff) / 255F;
-        float r2 = (float)(argb2 >> 16 & 0xff) / 255F;
-        float g2 = (float)(argb2 >> 8 & 0xff) / 255F;
-        float b2 = (float)(argb2 & 0xff) / 255F;
+        final float a1 = (float)(argb1 >> 24 & 0xff) / 255F;
+        final float r1 = (float)(argb1 >> 16 & 0xff) / 255F;
+        final float g1 = (float)(argb1 >> 8 & 0xff) / 255F;
+        final float b1 = (float)(argb1 & 0xff) / 255F;
+        final float a2 = (float)(argb2 >> 24 & 0xff) / 255F;
+        final float r2 = (float)(argb2 >> 16 & 0xff) / 255F;
+        final float g2 = (float)(argb2 >> 8 & 0xff) / 255F;
+        final float b2 = (float)(argb2 & 0xff) / 255F;
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glEnable(GL_BLEND);
         GL11.glDisable(GL_ALPHA_TEST);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glShadeModel(GL_SMOOTH);
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorRGBA_F(r1, g1, b1, a1);
         tessellator.addVertex(maxX, minY, 0.0D);
